from flask import render_template, Blueprint, request, redirect, url_for, flash
import requests
from collections import defaultdict

home_app = Blueprint('home', __name__)


@home_app.route('/backstage/home')
def home():
    response = requests.get('http://127.0.0.1:5000/api/home')
    if response.status_code == 200:
        return render_template('home.html',
                               title='首頁',
                               contents=response.json())


@home_app.route('/backstage/home/update', methods=['POST'])
def update():
    update_data = defaultdict(list)
    for key, value in request.form.items():
        element_type = key.split('-')[0]
        if element_type == 'img':
            value = eval(value)
        else:
            value = str(value)
        update_data[element_type].append(value)
    response = requests.post(
        'http://127.0.0.1:5000/api/gen/home?section={}'.format(
            request.args.get('section_class')), json=update_data)
    if response.status_code == 200:
        flash('修改成功', 'success')
    else:
        flash('修改失敗', 'danger')
    return redirect(url_for('home.home'))
